import { MyPLModel, PLModel } from "./pl.model";
import { MyStatusCodeModel, StatusCodeModel } from "./status-code.model";

export interface EvaluationCycleModel {
    evaluationRoundId: string
    companyId: string
    tdesc: string
    edesc: string
    apsyear: string
    apsPeriodStart: string
    apsPeriodEnd: string
    statusCode: StatusCodeModel
    personalLevel: PLModel[]

}

export class MyEvaluationCycleModel implements EvaluationCycleModel {
    evaluationRoundId: string
    companyId: string
    tdesc: string
    edesc: string
    apsyear: string
    apsPeriodStart: string
    apsPeriodEnd: string
    statusCode: StatusCodeModel
    personalLevel: PLModel[]
    constructor(data?: Partial<EvaluationCycleModel>) {
        this.evaluationRoundId = data?.evaluationRoundId || "";
        this.companyId = data?.companyId || "";
        this.tdesc = data?.tdesc || "";
        this.edesc = data?.edesc || "";
        this.apsyear = data?.apsyear || "";
        this.apsPeriodStart = data?.apsPeriodStart || "";
        this.apsPeriodEnd = data?.apsPeriodEnd || "";
        this.statusCode = new MyStatusCodeModel(data?.statusCode || {})
        this.personalLevel = data?.personalLevel?.map(x => new MyPLModel(x)) || []

    }
}
